unit Demo4Settings;
//  If you are using Delphi 6 Enterprise then disable this compiler directive :
{$DEFINE MyXML}
//  NOTE: Don't forget to apply the same change to FMain.pas

interface

uses
{$IFDEF MyXML}
  PtSettingsMyXML,
{$ELSE}
  PtSettingsXML,
{$ENDIF}
  PtSettings;

type
  TUserSettings = class(TSettingsGroup)
  private
    fStr: string;
    fInt: integer;
    fBool: Boolean;
  published
    property  Str : string    read fStr   write fStr;
    property  Int : integer   read fInt   write fInt;
    property  Bool  : Boolean read fBool  write fBool;
  end;

var
  UserSettings: TUserSettings;
  Storage: TXMLSettingsStorage;

procedure Initialize;
procedure Finalize;

implementation

uses
{$IFDEF MyXML}
  MyXML;
{$ELSE}
  XMLDoc;
{$ENDIF}

procedure Initialize;
begin
  UserSettings := TUserSettings.Create('Demo4', nil);
  Storage := TXMLSettingsStorage.Create( NewXMLDocument );
end;

procedure Finalize;
begin
  UserSettings.Free;
  Storage.Free;
end;

end.

