unit FStrIndex;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Spin, Grids, Demo8Settings;

type
  TfrmStrIndex = class(TForm)
    butClose: TButton;
    grpStrIndex: TGroupBox;
    butNew: TButton;
    butEdit: TButton;
    butDelete: TButton;
    labElemName: TLabel;
    edElemName: TEdit;
    labIntVal: TLabel;
    labStrVal: TLabel;
    edIntVal: TSpinEdit;
    edStrVal: TEdit;
    grdStrIndex: TStringGrid;
    labGrdGroupName: TLabel;
    labGrdIntVal: TLabel;
    labGrdStrVal: TLabel;
    procedure butNewClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lstChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure butCloseClick(Sender: TObject);
    procedure butEditClick(Sender: TObject);
    procedure butDeleteClick(Sender: TObject);
    procedure grdStrIndexSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
  private
    procedure ShowElems;
    function  SelectedElem: TElem;
  public
    { Public declarations }
  end;

var
  frmStrIndex: TfrmStrIndex;

implementation

{$R *.dfm}

{ TfrmMain }

procedure TfrmStrIndex.butCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmStrIndex.butDeleteClick(Sender: TObject);
begin
  Settings.StrIndex.RemElem( edElemName.Text );
  ShowElems;
end;

procedure TfrmStrIndex.butEditClick(Sender: TObject);
var
  Elem  : TElem;
begin
  Elem  := SelectedElem;
  Elem.GroupName  := edElemName.Text;
  Elem.IntVal     := edIntVal.Value;
  Elem.StrVal     := edStrVal.Text;
  ShowElems;
end;

procedure TfrmStrIndex.butNewClick(Sender: TObject);
var
  Elem  : TElem;
begin
  Elem        := Settings.StrIndex.AddElem( edElemName.Text );
  Elem.IntVal := edIntVal.Value;
  Elem.StrVal := edStrVal.Text;
  ShowElems;
end;

procedure TfrmStrIndex.FormCreate(Sender: TObject);
begin
  ShowElems;
end;

procedure TfrmStrIndex.grdStrIndexSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var
  Elem  : TElem;
begin
  if  SelectedElem = nil  then
    begin
      edElemName.Text := '';
      edIntVal.Value  := 0;
      edStrVal.Text   := '';
    end
  else
    begin
      Elem  := SelectedElem;
      edElemName.Text := Elem.GroupName;
      edIntVal.Value  := Elem.IntVal;
      edStrVal.Text   := Elem.StrVal;
    end;
end;

procedure TfrmStrIndex.lstChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
  Elem  : TElem;
begin
  if  Item = nil  then
    begin
      edElemName.Text := '';
      edIntVal.Value  := 0;
      edStrVal.Text   := '';
    end
  else if Item.Index < Settings.StrIndex.SubGroupCount  then
    begin
      Elem  := Item.Data;
      edElemName.Text := Elem.GroupName;
      edIntVal.Value  := Elem.IntVal;
      edStrVal.Text   := Elem.StrVal;
    end;
end;

function TfrmStrIndex.SelectedElem: TElem;
begin
  Result  := grdStrIndex.Objects[0, grdStrIndex.Row] as TElem;
end;

procedure TfrmStrIndex.ShowElems;
var
  Elem  : TElem;
  i : integer;
begin
  //  Empty the grid in case there is nothing to be shown
  grdStrIndex.Cells[0, 0]   := '';
  grdStrIndex.Cells[1, 0]   := '';
  grdStrIndex.Cells[2, 0]   := '';
  //  For each subgroup...
  grdStrIndex.RowCount  := Settings.StrIndex.SubGroupCount;
  for i := 0 to Settings.StrIndex.SubGroupCount-1 do
    begin
      Elem  := Settings.StrIndex.SubGroups[i] as TElem;
      //  ... fill in a row in the grid
      grdStrIndex.Objects[0, i] := Elem;
      grdStrIndex.Cells[0, i]   := Elem.GroupName;
      grdStrIndex.Cells[1, i]   := IntToStr( Elem.IntVal );
      grdStrIndex.Cells[2, i]   := Elem.StrVal;
    end;
end;

end.
